require 'git'
require 'fileutils'
module Hat
  class Recipes

    attr_accessor :url, :list

    def initialize options
      self.url = options['url']
      self.list = options['use'] || []
    end

    def download
      if File.directory?(url)
        FileUtils.rm_rf(dir) if File.directory?(dir)
        FileUtils.cp_r(url, Dir.tmpdir)
      else
        if File.directory?(dir)
          Git.open(dir).pull
        else
          Git.clone(url, repo_name, path: Dir.tmpdir)
        end
      end
    end

    def dir
      @dir ||= File.join(Dir.tmpdir, repo_name)
    end

    def gemfile
      File.join(dir, 'Gemfile')
    end

    private

    def repo_name
      @repo_name ||= File.basename(url, ".git")
    end

  end
end
