module Hat
  class Stage
    attr_accessor :name, :configuration

    def initialize name, configuration, list
      self.name = name.to_sym
      self.configuration = configuration
    end

    def set_defaults(defaults)
      configuration.merge!(Hash[defaults])
    end

    def define_task(recipes)
      conf = self.configuration
      name = self.name

      task = Rake::Task.define_task(name) do
        invoke 'load:defaults'
        conf.each do  |k, v|
          set k.to_sym, v
        end
        recipes.list.each{|l| load "#{recipes.dir}/recipes/#{l}.rb" }
        set(:stage, name)
        load "capistrano/#{fetch(:scm)}.rb"
        I18n.locale = fetch(:locale, :en)
        configure_backend
      end

    end

  end
end
